hgmp-0.1.2.1: Haskell interface to GMP

Safe Haskell | Safe-Inferred
Language | Haskell2010

Numeric.GMP.Types

Description

GMP types.

Synopsis

- data MPZ = MPZ {
  - mpzAlloc :: !CInt
  - mpzSize :: !CInt
  - mpzD :: !(Ptr MPLimb)
  }
- data MPQ = MPQ {
  - mpqNum :: !MPZ
  - mpqDen :: !MPZ
  }
- mpq_numref :: Ptr MPQ -> Ptr MPZ
- mpq_denref :: Ptr MPQ -> Ptr MPZ
- data MPF = MPF {
  - mpfPrec :: !CInt
  - mpfSize :: !CInt
  - mpfExp :: !MPExp
  - mpfD :: !(Ptr MPLimb)
  }
- data GMPRandState = GMPRandState {
  - gmprsSeed :: !MPZ
  - gmprsAlg :: !GMPRandAlg
  - gmprsAlgData :: !(Ptr ())
  }
- newtype MPLimb = MPLimb Word64
- newtype MPLimbSigned = MPLimbSigned Int64
- newtype MPSize = MPSize Int64
- newtype MPExp = MPExp Int64
- newtype MPBitCnt = MPBitCnt Word64
- newtype GMPRandAlg = GMPRandAlg Word32

# Documentation

data MPZ Source #

    mpz_t

Constructors

MPZ |

Fields

- mpzAlloc :: !CInt
- mpzSize :: !CInt
- mpzD :: !(Ptr MPLimb)

#### Instances

Instances details

Storable MPZ Source # |
Instance details Defined in Numeric.GMP.Types Methods sizeOf :: MPZ -> Int Source # alignment :: MPZ -> Int Source # peekElemOff :: Ptr MPZ -> Int -> IO MPZ Source # pokeElemOff :: Ptr MPZ -> Int -> MPZ -> IO () Source # peekByteOff :: Ptr b -> Int -> IO MPZ Source # pokeByteOff :: Ptr b -> Int -> MPZ -> IO () Source # peek :: Ptr MPZ -> IO MPZ Source # poke :: Ptr MPZ -> MPZ -> IO () Source #

data MPQ Source #

    mpq_t

Constructors

MPQ |

Fields

- mpqNum :: !MPZ
- mpqDen :: !MPZ

#### Instances

Instances details

Storable MPQ Source # |
Instance details Defined in Numeric.GMP.Types Methods sizeOf :: MPQ -> Int Source # alignment :: MPQ -> Int Source # peekElemOff :: Ptr MPQ -> Int -> IO MPQ Source # pokeElemOff :: Ptr MPQ -> Int -> MPQ -> IO () Source # peekByteOff :: Ptr b -> Int -> IO MPQ Source # pokeByteOff :: Ptr b -> Int -> MPQ -> IO () Source # peek :: Ptr MPQ -> IO MPQ Source # poke :: Ptr MPQ -> MPQ -> IO () Source #

mpq_numref :: Ptr MPQ -> Ptr MPZ Source #

Get pointers to numerator and denominator (these are macros in the C API).

mpq_denref :: Ptr MPQ -> Ptr MPZ Source #

Get pointers to numerator and denominator (these are macros in the C API).

data MPF Source #

    mpf_t

Constructors

MPF |

Fields

- mpfPrec :: !CInt
- mpfSize :: !CInt
- mpfExp :: !MPExp
- mpfD :: !(Ptr MPLimb)

#### Instances

Instances details

Storable MPF Source # |
Instance details Defined in Numeric.GMP.Types Methods sizeOf :: MPF -> Int Source # alignment :: MPF -> Int Source # peekElemOff :: Ptr MPF -> Int -> IO MPF Source # pokeElemOff :: Ptr MPF -> Int -> MPF -> IO () Source # peekByteOff :: Ptr b -> Int -> IO MPF Source # pokeByteOff :: Ptr b -> Int -> MPF -> IO () Source # peek :: Ptr MPF -> IO MPF Source # poke :: Ptr MPF -> MPF -> IO () Source #

data GMPRandState Source #

    gmp_randstate_t

Constructors

GMPRandState |

Fields

- gmprsSeed :: !MPZ
- gmprsAlg :: !GMPRandAlg
- gmprsAlgData :: !(Ptr ())

#### Instances

Instances details

Storable GMPRandState Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

sizeOf :: GMPRandState -> Int Source #

alignment :: GMPRandState -> Int Source #

peekElemOff :: Ptr GMPRandState -> Int -> IO GMPRandState Source #

pokeElemOff :: Ptr GMPRandState -> Int -> GMPRandState -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO GMPRandState Source #

pokeByteOff :: Ptr b -> Int -> GMPRandState -> IO () Source #

peek :: Ptr GMPRandState -> IO GMPRandState Source #

poke :: Ptr GMPRandState -> GMPRandState -> IO () Source #

newtype MPLimb Source #

    mp_limb_t

Constructors

MPLimb Word64 |

#### Instances

Instances details

Data MPLimb Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> MPLimb -> c MPLimb Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c MPLimb Source #

toConstr :: MPLimb -> Constr Source #

dataTypeOf :: MPLimb -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c MPLimb) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c MPLimb) Source #

gmapT :: (forall b. Data b => b -> b) -> MPLimb -> MPLimb Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> MPLimb -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> MPLimb -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> MPLimb -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> MPLimb -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> MPLimb -> m MPLimb Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> MPLimb -> m MPLimb Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> MPLimb -> m MPLimb Source #

Storable MPLimb Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

sizeOf :: MPLimb -> Int Source #

alignment :: MPLimb -> Int Source #

peekElemOff :: Ptr MPLimb -> Int -> IO MPLimb Source #

pokeElemOff :: Ptr MPLimb -> Int -> MPLimb -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO MPLimb Source #

pokeByteOff :: Ptr b -> Int -> MPLimb -> IO () Source #

peek :: Ptr MPLimb -> IO MPLimb Source #

poke :: Ptr MPLimb -> MPLimb -> IO () Source #

Bits MPLimb Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

(.&.) :: MPLimb -> MPLimb -> MPLimb Source #

(.|.) :: MPLimb -> MPLimb -> MPLimb Source #

xor :: MPLimb -> MPLimb -> MPLimb Source #

complement :: MPLimb -> MPLimb Source #

shift :: MPLimb -> Int -> MPLimb Source #

rotate :: MPLimb -> Int -> MPLimb Source #

zeroBits :: MPLimb Source #

bit :: Int -> MPLimb Source #

setBit :: MPLimb -> Int -> MPLimb Source #

clearBit :: MPLimb -> Int -> MPLimb Source #

complementBit :: MPLimb -> Int -> MPLimb Source #

testBit :: MPLimb -> Int -> Bool Source #

bitSizeMaybe :: MPLimb -> Maybe Int Source #

bitSize :: MPLimb -> Int Source #

isSigned :: MPLimb -> Bool Source #

shiftL :: MPLimb -> Int -> MPLimb Source #

unsafeShiftL :: MPLimb -> Int -> MPLimb Source #

shiftR :: MPLimb -> Int -> MPLimb Source #

unsafeShiftR :: MPLimb -> Int -> MPLimb Source #

rotateL :: MPLimb -> Int -> MPLimb Source #

rotateR :: MPLimb -> Int -> MPLimb Source #

popCount :: MPLimb -> Int Source #

FiniteBits MPLimb Source # |
Instance details Defined in Numeric.GMP.Types Methods finiteBitSize :: MPLimb -> Int Source # countLeadingZeros :: MPLimb -> Int Source # countTrailingZeros :: MPLimb -> Int Source #
Bounded MPLimb Source # |
Instance details Defined in Numeric.GMP.Types Methods minBound :: MPLimb Source # maxBound :: MPLimb Source #
Enum MPLimb Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

succ :: MPLimb -> MPLimb Source #

pred :: MPLimb -> MPLimb Source #

toEnum :: Int -> MPLimb Source #

fromEnum :: MPLimb -> Int Source #

enumFrom :: MPLimb -> [MPLimb] Source #

enumFromThen :: MPLimb -> MPLimb -> [MPLimb] Source #

enumFromTo :: MPLimb -> MPLimb -> [MPLimb] Source #

enumFromThenTo :: MPLimb -> MPLimb -> MPLimb -> [MPLimb] Source #

Ix MPLimb Source # |
Instance details Defined in Numeric.GMP.Types Methods range :: (MPLimb, MPLimb) -> [MPLimb] Source # index :: (MPLimb, MPLimb) -> MPLimb -> Int Source # unsafeIndex :: (MPLimb, MPLimb) -> MPLimb -> Int Source # inRange :: (MPLimb, MPLimb) -> MPLimb -> Bool Source # rangeSize :: (MPLimb, MPLimb) -> Int Source # unsafeRangeSize :: (MPLimb, MPLimb) -> Int Source #
Num MPLimb Source # |
Instance details Defined in Numeric.GMP.Types Methods (+) :: MPLimb -> MPLimb -> MPLimb Source # (-) :: MPLimb -> MPLimb -> MPLimb Source # (*) :: MPLimb -> MPLimb -> MPLimb Source # negate :: MPLimb -> MPLimb Source # abs :: MPLimb -> MPLimb Source # signum :: MPLimb -> MPLimb Source # fromInteger :: Integer -> MPLimb Source #
Read MPLimb Source # |
Instance details Defined in Numeric.GMP.Types Methods readsPrec :: Int -> ReadS MPLimb Source # readList :: ReadS [MPLimb] Source # readPrec :: ReadPrec MPLimb Source # readListPrec :: ReadPrec [MPLimb] Source #
Integral MPLimb Source # |
Instance details Defined in Numeric.GMP.Types Methods quot :: MPLimb -> MPLimb -> MPLimb Source # rem :: MPLimb -> MPLimb -> MPLimb Source # div :: MPLimb -> MPLimb -> MPLimb Source # mod :: MPLimb -> MPLimb -> MPLimb Source # quotRem :: MPLimb -> MPLimb -> (MPLimb, MPLimb) Source # divMod :: MPLimb -> MPLimb -> (MPLimb, MPLimb) Source # toInteger :: MPLimb -> Integer Source #
Real MPLimb Source # |
Instance details Defined in Numeric.GMP.Types Methods toRational :: MPLimb -> Rational Source #
Show MPLimb Source # |
Instance details Defined in Numeric.GMP.Types Methods showsPrec :: Int -> MPLimb -> ShowS Source # show :: MPLimb -> String Source # showList :: [MPLimb] -> ShowS Source #
Eq MPLimb Source # |
Instance details Defined in Numeric.GMP.Types Methods (==) :: MPLimb -> MPLimb -> Bool Source # (/=) :: MPLimb -> MPLimb -> Bool Source #
Ord MPLimb Source # |
Instance details Defined in Numeric.GMP.Types Methods compare :: MPLimb -> MPLimb -> Ordering Source # (<) :: MPLimb -> MPLimb -> Bool Source # (<=) :: MPLimb -> MPLimb -> Bool Source # (>) :: MPLimb -> MPLimb -> Bool Source # (>=) :: MPLimb -> MPLimb -> Bool Source # max :: MPLimb -> MPLimb -> MPLimb Source # min :: MPLimb -> MPLimb -> MPLimb Source #

newtype MPLimbSigned Source #

    mp_limb_signed_t

Constructors

MPLimbSigned Int64 |

#### Instances

Instances details

Data MPLimbSigned Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> MPLimbSigned -> c MPLimbSigned Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c MPLimbSigned Source #

toConstr :: MPLimbSigned -> Constr Source #

dataTypeOf :: MPLimbSigned -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c MPLimbSigned) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c MPLimbSigned) Source #

gmapT :: (forall b. Data b => b -> b) -> MPLimbSigned -> MPLimbSigned Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> MPLimbSigned -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> MPLimbSigned -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> MPLimbSigned -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> MPLimbSigned -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> MPLimbSigned -> m MPLimbSigned Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> MPLimbSigned -> m MPLimbSigned Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> MPLimbSigned -> m MPLimbSigned Source #

Storable MPLimbSigned Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

sizeOf :: MPLimbSigned -> Int Source #

alignment :: MPLimbSigned -> Int Source #

peekElemOff :: Ptr MPLimbSigned -> Int -> IO MPLimbSigned Source #

pokeElemOff :: Ptr MPLimbSigned -> Int -> MPLimbSigned -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO MPLimbSigned Source #

pokeByteOff :: Ptr b -> Int -> MPLimbSigned -> IO () Source #

peek :: Ptr MPLimbSigned -> IO MPLimbSigned Source #

poke :: Ptr MPLimbSigned -> MPLimbSigned -> IO () Source #

Bits MPLimbSigned Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

(.&.) :: MPLimbSigned -> MPLimbSigned -> MPLimbSigned Source #

(.|.) :: MPLimbSigned -> MPLimbSigned -> MPLimbSigned Source #

xor :: MPLimbSigned -> MPLimbSigned -> MPLimbSigned Source #

complement :: MPLimbSigned -> MPLimbSigned Source #

shift :: MPLimbSigned -> Int -> MPLimbSigned Source #

rotate :: MPLimbSigned -> Int -> MPLimbSigned Source #

zeroBits :: MPLimbSigned Source #

bit :: Int -> MPLimbSigned Source #

setBit :: MPLimbSigned -> Int -> MPLimbSigned Source #

clearBit :: MPLimbSigned -> Int -> MPLimbSigned Source #

complementBit :: MPLimbSigned -> Int -> MPLimbSigned Source #

testBit :: MPLimbSigned -> Int -> Bool Source #

bitSizeMaybe :: MPLimbSigned -> Maybe Int Source #

bitSize :: MPLimbSigned -> Int Source #

isSigned :: MPLimbSigned -> Bool Source #

shiftL :: MPLimbSigned -> Int -> MPLimbSigned Source #

unsafeShiftL :: MPLimbSigned -> Int -> MPLimbSigned Source #

shiftR :: MPLimbSigned -> Int -> MPLimbSigned Source #

unsafeShiftR :: MPLimbSigned -> Int -> MPLimbSigned Source #

rotateL :: MPLimbSigned -> Int -> MPLimbSigned Source #

rotateR :: MPLimbSigned -> Int -> MPLimbSigned Source #

popCount :: MPLimbSigned -> Int Source #

FiniteBits MPLimbSigned Source # |
Instance details Defined in Numeric.GMP.Types Methods finiteBitSize :: MPLimbSigned -> Int Source # countLeadingZeros :: MPLimbSigned -> Int Source # countTrailingZeros :: MPLimbSigned -> Int Source #
Bounded MPLimbSigned Source # |
Instance details Defined in Numeric.GMP.Types Methods minBound :: MPLimbSigned Source # maxBound :: MPLimbSigned Source #
Enum MPLimbSigned Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

succ :: MPLimbSigned -> MPLimbSigned Source #

pred :: MPLimbSigned -> MPLimbSigned Source #

toEnum :: Int -> MPLimbSigned Source #

fromEnum :: MPLimbSigned -> Int Source #

enumFrom :: MPLimbSigned -> [MPLimbSigned] Source #

enumFromThen :: MPLimbSigned -> MPLimbSigned -> [MPLimbSigned] Source #

enumFromTo :: MPLimbSigned -> MPLimbSigned -> [MPLimbSigned] Source #

enumFromThenTo :: MPLimbSigned -> MPLimbSigned -> MPLimbSigned -> [MPLimbSigned] Source #

Ix MPLimbSigned Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

range :: (MPLimbSigned, MPLimbSigned) -> [MPLimbSigned] Source #

index :: (MPLimbSigned, MPLimbSigned) -> MPLimbSigned -> Int Source #

unsafeIndex :: (MPLimbSigned, MPLimbSigned) -> MPLimbSigned -> Int Source #

inRange :: (MPLimbSigned, MPLimbSigned) -> MPLimbSigned -> Bool Source #

rangeSize :: (MPLimbSigned, MPLimbSigned) -> Int Source #

unsafeRangeSize :: (MPLimbSigned, MPLimbSigned) -> Int Source #

Num MPLimbSigned Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

(+) :: MPLimbSigned -> MPLimbSigned -> MPLimbSigned Source #

(-) :: MPLimbSigned -> MPLimbSigned -> MPLimbSigned Source #

(*) :: MPLimbSigned -> MPLimbSigned -> MPLimbSigned Source #

negate :: MPLimbSigned -> MPLimbSigned Source #

abs :: MPLimbSigned -> MPLimbSigned Source #

signum :: MPLimbSigned -> MPLimbSigned Source #

fromInteger :: Integer -> MPLimbSigned Source #

Read MPLimbSigned Source # |
Instance details Defined in Numeric.GMP.Types Methods readsPrec :: Int -> ReadS MPLimbSigned Source # readList :: ReadS [MPLimbSigned] Source # readPrec :: ReadPrec MPLimbSigned Source # readListPrec :: ReadPrec [MPLimbSigned] Source #
Integral MPLimbSigned Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

quot :: MPLimbSigned -> MPLimbSigned -> MPLimbSigned Source #

rem :: MPLimbSigned -> MPLimbSigned -> MPLimbSigned Source #

div :: MPLimbSigned -> MPLimbSigned -> MPLimbSigned Source #

mod :: MPLimbSigned -> MPLimbSigned -> MPLimbSigned Source #

quotRem :: MPLimbSigned -> MPLimbSigned -> (MPLimbSigned, MPLimbSigned) Source #

divMod :: MPLimbSigned -> MPLimbSigned -> (MPLimbSigned, MPLimbSigned) Source #

toInteger :: MPLimbSigned -> Integer Source #

Real MPLimbSigned Source # |
Instance details Defined in Numeric.GMP.Types Methods toRational :: MPLimbSigned -> Rational Source #
Show MPLimbSigned Source # |
Instance details Defined in Numeric.GMP.Types Methods showsPrec :: Int -> MPLimbSigned -> ShowS Source # show :: MPLimbSigned -> String Source # showList :: [MPLimbSigned] -> ShowS Source #
Eq MPLimbSigned Source # |
Instance details Defined in Numeric.GMP.Types Methods (==) :: MPLimbSigned -> MPLimbSigned -> Bool Source # (/=) :: MPLimbSigned -> MPLimbSigned -> Bool Source #
Ord MPLimbSigned Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

compare :: MPLimbSigned -> MPLimbSigned -> Ordering Source #

(<) :: MPLimbSigned -> MPLimbSigned -> Bool Source #

(<=) :: MPLimbSigned -> MPLimbSigned -> Bool Source #

(>) :: MPLimbSigned -> MPLimbSigned -> Bool Source #

(>=) :: MPLimbSigned -> MPLimbSigned -> Bool Source #

max :: MPLimbSigned -> MPLimbSigned -> MPLimbSigned Source #

min :: MPLimbSigned -> MPLimbSigned -> MPLimbSigned Source #

newtype MPSize Source #

    mp_size_t

Constructors

MPSize Int64 |

#### Instances

Instances details

Data MPSize Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> MPSize -> c MPSize Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c MPSize Source #

toConstr :: MPSize -> Constr Source #

dataTypeOf :: MPSize -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c MPSize) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c MPSize) Source #

gmapT :: (forall b. Data b => b -> b) -> MPSize -> MPSize Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> MPSize -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> MPSize -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> MPSize -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> MPSize -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> MPSize -> m MPSize Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> MPSize -> m MPSize Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> MPSize -> m MPSize Source #

Storable MPSize Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

sizeOf :: MPSize -> Int Source #

alignment :: MPSize -> Int Source #

peekElemOff :: Ptr MPSize -> Int -> IO MPSize Source #

pokeElemOff :: Ptr MPSize -> Int -> MPSize -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO MPSize Source #

pokeByteOff :: Ptr b -> Int -> MPSize -> IO () Source #

peek :: Ptr MPSize -> IO MPSize Source #

poke :: Ptr MPSize -> MPSize -> IO () Source #

Bits MPSize Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

(.&.) :: MPSize -> MPSize -> MPSize Source #

(.|.) :: MPSize -> MPSize -> MPSize Source #

xor :: MPSize -> MPSize -> MPSize Source #

complement :: MPSize -> MPSize Source #

shift :: MPSize -> Int -> MPSize Source #

rotate :: MPSize -> Int -> MPSize Source #

zeroBits :: MPSize Source #

bit :: Int -> MPSize Source #

setBit :: MPSize -> Int -> MPSize Source #

clearBit :: MPSize -> Int -> MPSize Source #

complementBit :: MPSize -> Int -> MPSize Source #

testBit :: MPSize -> Int -> Bool Source #

bitSizeMaybe :: MPSize -> Maybe Int Source #

bitSize :: MPSize -> Int Source #

isSigned :: MPSize -> Bool Source #

shiftL :: MPSize -> Int -> MPSize Source #

unsafeShiftL :: MPSize -> Int -> MPSize Source #

shiftR :: MPSize -> Int -> MPSize Source #

unsafeShiftR :: MPSize -> Int -> MPSize Source #

rotateL :: MPSize -> Int -> MPSize Source #

rotateR :: MPSize -> Int -> MPSize Source #

popCount :: MPSize -> Int Source #

FiniteBits MPSize Source # |
Instance details Defined in Numeric.GMP.Types Methods finiteBitSize :: MPSize -> Int Source # countLeadingZeros :: MPSize -> Int Source # countTrailingZeros :: MPSize -> Int Source #
Bounded MPSize Source # |
Instance details Defined in Numeric.GMP.Types Methods minBound :: MPSize Source # maxBound :: MPSize Source #
Enum MPSize Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

succ :: MPSize -> MPSize Source #

pred :: MPSize -> MPSize Source #

toEnum :: Int -> MPSize Source #

fromEnum :: MPSize -> Int Source #

enumFrom :: MPSize -> [MPSize] Source #

enumFromThen :: MPSize -> MPSize -> [MPSize] Source #

enumFromTo :: MPSize -> MPSize -> [MPSize] Source #

enumFromThenTo :: MPSize -> MPSize -> MPSize -> [MPSize] Source #

Ix MPSize Source # |
Instance details Defined in Numeric.GMP.Types Methods range :: (MPSize, MPSize) -> [MPSize] Source # index :: (MPSize, MPSize) -> MPSize -> Int Source # unsafeIndex :: (MPSize, MPSize) -> MPSize -> Int Source # inRange :: (MPSize, MPSize) -> MPSize -> Bool Source # rangeSize :: (MPSize, MPSize) -> Int Source # unsafeRangeSize :: (MPSize, MPSize) -> Int Source #
Num MPSize Source # |
Instance details Defined in Numeric.GMP.Types Methods (+) :: MPSize -> MPSize -> MPSize Source # (-) :: MPSize -> MPSize -> MPSize Source # (*) :: MPSize -> MPSize -> MPSize Source # negate :: MPSize -> MPSize Source # abs :: MPSize -> MPSize Source # signum :: MPSize -> MPSize Source # fromInteger :: Integer -> MPSize Source #
Read MPSize Source # |
Instance details Defined in Numeric.GMP.Types Methods readsPrec :: Int -> ReadS MPSize Source # readList :: ReadS [MPSize] Source # readPrec :: ReadPrec MPSize Source # readListPrec :: ReadPrec [MPSize] Source #
Integral MPSize Source # |
Instance details Defined in Numeric.GMP.Types Methods quot :: MPSize -> MPSize -> MPSize Source # rem :: MPSize -> MPSize -> MPSize Source # div :: MPSize -> MPSize -> MPSize Source # mod :: MPSize -> MPSize -> MPSize Source # quotRem :: MPSize -> MPSize -> (MPSize, MPSize) Source # divMod :: MPSize -> MPSize -> (MPSize, MPSize) Source # toInteger :: MPSize -> Integer Source #
Real MPSize Source # |
Instance details Defined in Numeric.GMP.Types Methods toRational :: MPSize -> Rational Source #
Show MPSize Source # |
Instance details Defined in Numeric.GMP.Types Methods showsPrec :: Int -> MPSize -> ShowS Source # show :: MPSize -> String Source # showList :: [MPSize] -> ShowS Source #
Eq MPSize Source # |
Instance details Defined in Numeric.GMP.Types Methods (==) :: MPSize -> MPSize -> Bool Source # (/=) :: MPSize -> MPSize -> Bool Source #
Ord MPSize Source # |
Instance details Defined in Numeric.GMP.Types Methods compare :: MPSize -> MPSize -> Ordering Source # (<) :: MPSize -> MPSize -> Bool Source # (<=) :: MPSize -> MPSize -> Bool Source # (>) :: MPSize -> MPSize -> Bool Source # (>=) :: MPSize -> MPSize -> Bool Source # max :: MPSize -> MPSize -> MPSize Source # min :: MPSize -> MPSize -> MPSize Source #

newtype MPExp Source #

    mp_exp_t

Constructors

MPExp Int64 |

#### Instances

Instances details

Data MPExp Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> MPExp -> c MPExp Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c MPExp Source #

toConstr :: MPExp -> Constr Source #

dataTypeOf :: MPExp -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c MPExp) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c MPExp) Source #

gmapT :: (forall b. Data b => b -> b) -> MPExp -> MPExp Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> MPExp -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> MPExp -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> MPExp -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> MPExp -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> MPExp -> m MPExp Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> MPExp -> m MPExp Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> MPExp -> m MPExp Source #

Storable MPExp Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

sizeOf :: MPExp -> Int Source #

alignment :: MPExp -> Int Source #

peekElemOff :: Ptr MPExp -> Int -> IO MPExp Source #

pokeElemOff :: Ptr MPExp -> Int -> MPExp -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO MPExp Source #

pokeByteOff :: Ptr b -> Int -> MPExp -> IO () Source #

peek :: Ptr MPExp -> IO MPExp Source #

poke :: Ptr MPExp -> MPExp -> IO () Source #

Bits MPExp Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

(.&.) :: MPExp -> MPExp -> MPExp Source #

(.|.) :: MPExp -> MPExp -> MPExp Source #

xor :: MPExp -> MPExp -> MPExp Source #

complement :: MPExp -> MPExp Source #

shift :: MPExp -> Int -> MPExp Source #

rotate :: MPExp -> Int -> MPExp Source #

zeroBits :: MPExp Source #

bit :: Int -> MPExp Source #

setBit :: MPExp -> Int -> MPExp Source #

clearBit :: MPExp -> Int -> MPExp Source #

complementBit :: MPExp -> Int -> MPExp Source #

testBit :: MPExp -> Int -> Bool Source #

bitSizeMaybe :: MPExp -> Maybe Int Source #

bitSize :: MPExp -> Int Source #

isSigned :: MPExp -> Bool Source #

shiftL :: MPExp -> Int -> MPExp Source #

unsafeShiftL :: MPExp -> Int -> MPExp Source #

shiftR :: MPExp -> Int -> MPExp Source #

unsafeShiftR :: MPExp -> Int -> MPExp Source #

rotateL :: MPExp -> Int -> MPExp Source #

rotateR :: MPExp -> Int -> MPExp Source #

popCount :: MPExp -> Int Source #

FiniteBits MPExp Source # |
Instance details Defined in Numeric.GMP.Types Methods finiteBitSize :: MPExp -> Int Source # countLeadingZeros :: MPExp -> Int Source # countTrailingZeros :: MPExp -> Int Source #
Bounded MPExp Source # |
Instance details Defined in Numeric.GMP.Types Methods minBound :: MPExp Source # maxBound :: MPExp Source #
Enum MPExp Source # |
Instance details Defined in Numeric.GMP.Types Methods succ :: MPExp -> MPExp Source # pred :: MPExp -> MPExp Source # toEnum :: Int -> MPExp Source # fromEnum :: MPExp -> Int Source # enumFrom :: MPExp -> [MPExp] Source # enumFromThen :: MPExp -> MPExp -> [MPExp] Source # enumFromTo :: MPExp -> MPExp -> [MPExp] Source # enumFromThenTo :: MPExp -> MPExp -> MPExp -> [MPExp] Source #
Ix MPExp Source # |
Instance details Defined in Numeric.GMP.Types Methods range :: (MPExp, MPExp) -> [MPExp] Source # index :: (MPExp, MPExp) -> MPExp -> Int Source # unsafeIndex :: (MPExp, MPExp) -> MPExp -> Int Source # inRange :: (MPExp, MPExp) -> MPExp -> Bool Source # rangeSize :: (MPExp, MPExp) -> Int Source # unsafeRangeSize :: (MPExp, MPExp) -> Int Source #
Num MPExp Source # |
Instance details Defined in Numeric.GMP.Types Methods (+) :: MPExp -> MPExp -> MPExp Source # (-) :: MPExp -> MPExp -> MPExp Source # (*) :: MPExp -> MPExp -> MPExp Source # negate :: MPExp -> MPExp Source # abs :: MPExp -> MPExp Source # signum :: MPExp -> MPExp Source # fromInteger :: Integer -> MPExp Source #
Read MPExp Source # |
Instance details Defined in Numeric.GMP.Types Methods readsPrec :: Int -> ReadS MPExp Source # readList :: ReadS [MPExp] Source # readPrec :: ReadPrec MPExp Source # readListPrec :: ReadPrec [MPExp] Source #
Integral MPExp Source # |
Instance details Defined in Numeric.GMP.Types Methods quot :: MPExp -> MPExp -> MPExp Source # rem :: MPExp -> MPExp -> MPExp Source # div :: MPExp -> MPExp -> MPExp Source # mod :: MPExp -> MPExp -> MPExp Source # quotRem :: MPExp -> MPExp -> (MPExp, MPExp) Source # divMod :: MPExp -> MPExp -> (MPExp, MPExp) Source # toInteger :: MPExp -> Integer Source #
Real MPExp Source # |
Instance details Defined in Numeric.GMP.Types Methods toRational :: MPExp -> Rational Source #
Show MPExp Source # |
Instance details Defined in Numeric.GMP.Types Methods showsPrec :: Int -> MPExp -> ShowS Source # show :: MPExp -> String Source # showList :: [MPExp] -> ShowS Source #
Eq MPExp Source # |
Instance details Defined in Numeric.GMP.Types Methods (==) :: MPExp -> MPExp -> Bool Source # (/=) :: MPExp -> MPExp -> Bool Source #
Ord MPExp Source # |
Instance details Defined in Numeric.GMP.Types Methods compare :: MPExp -> MPExp -> Ordering Source # (<) :: MPExp -> MPExp -> Bool Source # (<=) :: MPExp -> MPExp -> Bool Source # (>) :: MPExp -> MPExp -> Bool Source # (>=) :: MPExp -> MPExp -> Bool Source # max :: MPExp -> MPExp -> MPExp Source # min :: MPExp -> MPExp -> MPExp Source #

newtype MPBitCnt Source #

    mp_bitcnt_t

Constructors

MPBitCnt Word64 |

#### Instances

Instances details

Data MPBitCnt Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> MPBitCnt -> c MPBitCnt Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c MPBitCnt Source #

toConstr :: MPBitCnt -> Constr Source #

dataTypeOf :: MPBitCnt -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c MPBitCnt) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c MPBitCnt) Source #

gmapT :: (forall b. Data b => b -> b) -> MPBitCnt -> MPBitCnt Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> MPBitCnt -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> MPBitCnt -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> MPBitCnt -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> MPBitCnt -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> MPBitCnt -> m MPBitCnt Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> MPBitCnt -> m MPBitCnt Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> MPBitCnt -> m MPBitCnt Source #

Storable MPBitCnt Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

sizeOf :: MPBitCnt -> Int Source #

alignment :: MPBitCnt -> Int Source #

peekElemOff :: Ptr MPBitCnt -> Int -> IO MPBitCnt Source #

pokeElemOff :: Ptr MPBitCnt -> Int -> MPBitCnt -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO MPBitCnt Source #

pokeByteOff :: Ptr b -> Int -> MPBitCnt -> IO () Source #

peek :: Ptr MPBitCnt -> IO MPBitCnt Source #

poke :: Ptr MPBitCnt -> MPBitCnt -> IO () Source #

Bits MPBitCnt Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

(.&.) :: MPBitCnt -> MPBitCnt -> MPBitCnt Source #

(.|.) :: MPBitCnt -> MPBitCnt -> MPBitCnt Source #

xor :: MPBitCnt -> MPBitCnt -> MPBitCnt Source #

complement :: MPBitCnt -> MPBitCnt Source #

shift :: MPBitCnt -> Int -> MPBitCnt Source #

rotate :: MPBitCnt -> Int -> MPBitCnt Source #

zeroBits :: MPBitCnt Source #

bit :: Int -> MPBitCnt Source #

setBit :: MPBitCnt -> Int -> MPBitCnt Source #

clearBit :: MPBitCnt -> Int -> MPBitCnt Source #

complementBit :: MPBitCnt -> Int -> MPBitCnt Source #

testBit :: MPBitCnt -> Int -> Bool Source #

bitSizeMaybe :: MPBitCnt -> Maybe Int Source #

bitSize :: MPBitCnt -> Int Source #

isSigned :: MPBitCnt -> Bool Source #

shiftL :: MPBitCnt -> Int -> MPBitCnt Source #

unsafeShiftL :: MPBitCnt -> Int -> MPBitCnt Source #

shiftR :: MPBitCnt -> Int -> MPBitCnt Source #

unsafeShiftR :: MPBitCnt -> Int -> MPBitCnt Source #

rotateL :: MPBitCnt -> Int -> MPBitCnt Source #

rotateR :: MPBitCnt -> Int -> MPBitCnt Source #

popCount :: MPBitCnt -> Int Source #

FiniteBits MPBitCnt Source # |
Instance details Defined in Numeric.GMP.Types Methods finiteBitSize :: MPBitCnt -> Int Source # countLeadingZeros :: MPBitCnt -> Int Source # countTrailingZeros :: MPBitCnt -> Int Source #
Bounded MPBitCnt Source # |
Instance details Defined in Numeric.GMP.Types Methods minBound :: MPBitCnt Source # maxBound :: MPBitCnt Source #
Enum MPBitCnt Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

succ :: MPBitCnt -> MPBitCnt Source #

pred :: MPBitCnt -> MPBitCnt Source #

toEnum :: Int -> MPBitCnt Source #

fromEnum :: MPBitCnt -> Int Source #

enumFrom :: MPBitCnt -> [MPBitCnt] Source #

enumFromThen :: MPBitCnt -> MPBitCnt -> [MPBitCnt] Source #

enumFromTo :: MPBitCnt -> MPBitCnt -> [MPBitCnt] Source #

enumFromThenTo :: MPBitCnt -> MPBitCnt -> MPBitCnt -> [MPBitCnt] Source #

Ix MPBitCnt Source # |
Instance details Defined in Numeric.GMP.Types Methods range :: (MPBitCnt, MPBitCnt) -> [MPBitCnt] Source # index :: (MPBitCnt, MPBitCnt) -> MPBitCnt -> Int Source # unsafeIndex :: (MPBitCnt, MPBitCnt) -> MPBitCnt -> Int Source # inRange :: (MPBitCnt, MPBitCnt) -> MPBitCnt -> Bool Source # rangeSize :: (MPBitCnt, MPBitCnt) -> Int Source # unsafeRangeSize :: (MPBitCnt, MPBitCnt) -> Int Source #
Num MPBitCnt Source # |
Instance details Defined in Numeric.GMP.Types Methods (+) :: MPBitCnt -> MPBitCnt -> MPBitCnt Source # (-) :: MPBitCnt -> MPBitCnt -> MPBitCnt Source # (*) :: MPBitCnt -> MPBitCnt -> MPBitCnt Source # negate :: MPBitCnt -> MPBitCnt Source # abs :: MPBitCnt -> MPBitCnt Source # signum :: MPBitCnt -> MPBitCnt Source # fromInteger :: Integer -> MPBitCnt Source #
Read MPBitCnt Source # |
Instance details Defined in Numeric.GMP.Types Methods readsPrec :: Int -> ReadS MPBitCnt Source # readList :: ReadS [MPBitCnt] Source # readPrec :: ReadPrec MPBitCnt Source # readListPrec :: ReadPrec [MPBitCnt] Source #
Integral MPBitCnt Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

quot :: MPBitCnt -> MPBitCnt -> MPBitCnt Source #

rem :: MPBitCnt -> MPBitCnt -> MPBitCnt Source #

div :: MPBitCnt -> MPBitCnt -> MPBitCnt Source #

mod :: MPBitCnt -> MPBitCnt -> MPBitCnt Source #

quotRem :: MPBitCnt -> MPBitCnt -> (MPBitCnt, MPBitCnt) Source #

divMod :: MPBitCnt -> MPBitCnt -> (MPBitCnt, MPBitCnt) Source #

toInteger :: MPBitCnt -> Integer Source #

Real MPBitCnt Source # |
Instance details Defined in Numeric.GMP.Types Methods toRational :: MPBitCnt -> Rational Source #
Show MPBitCnt Source # |
Instance details Defined in Numeric.GMP.Types Methods showsPrec :: Int -> MPBitCnt -> ShowS Source # show :: MPBitCnt -> String Source # showList :: [MPBitCnt] -> ShowS Source #
Eq MPBitCnt Source # |
Instance details Defined in Numeric.GMP.Types Methods (==) :: MPBitCnt -> MPBitCnt -> Bool Source # (/=) :: MPBitCnt -> MPBitCnt -> Bool Source #
Ord MPBitCnt Source # |
Instance details Defined in Numeric.GMP.Types Methods compare :: MPBitCnt -> MPBitCnt -> Ordering Source # (<) :: MPBitCnt -> MPBitCnt -> Bool Source # (<=) :: MPBitCnt -> MPBitCnt -> Bool Source # (>) :: MPBitCnt -> MPBitCnt -> Bool Source # (>=) :: MPBitCnt -> MPBitCnt -> Bool Source # max :: MPBitCnt -> MPBitCnt -> MPBitCnt Source # min :: MPBitCnt -> MPBitCnt -> MPBitCnt Source #

newtype GMPRandAlg Source #

    gmp_randalg_t

Constructors

GMPRandAlg Word32 |

#### Instances

Instances details

Data GMPRandAlg Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> GMPRandAlg -> c GMPRandAlg Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c GMPRandAlg Source #

toConstr :: GMPRandAlg -> Constr Source #

dataTypeOf :: GMPRandAlg -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c GMPRandAlg) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c GMPRandAlg) Source #

gmapT :: (forall b. Data b => b -> b) -> GMPRandAlg -> GMPRandAlg Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> GMPRandAlg -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> GMPRandAlg -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> GMPRandAlg -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> GMPRandAlg -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> GMPRandAlg -> m GMPRandAlg Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> GMPRandAlg -> m GMPRandAlg Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> GMPRandAlg -> m GMPRandAlg Source #

Storable GMPRandAlg Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

sizeOf :: GMPRandAlg -> Int Source #

alignment :: GMPRandAlg -> Int Source #

peekElemOff :: Ptr GMPRandAlg -> Int -> IO GMPRandAlg Source #

pokeElemOff :: Ptr GMPRandAlg -> Int -> GMPRandAlg -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO GMPRandAlg Source #

pokeByteOff :: Ptr b -> Int -> GMPRandAlg -> IO () Source #

peek :: Ptr GMPRandAlg -> IO GMPRandAlg Source #

poke :: Ptr GMPRandAlg -> GMPRandAlg -> IO () Source #

Bits GMPRandAlg Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

(.&.) :: GMPRandAlg -> GMPRandAlg -> GMPRandAlg Source #

(.|.) :: GMPRandAlg -> GMPRandAlg -> GMPRandAlg Source #

xor :: GMPRandAlg -> GMPRandAlg -> GMPRandAlg Source #

complement :: GMPRandAlg -> GMPRandAlg Source #

shift :: GMPRandAlg -> Int -> GMPRandAlg Source #

rotate :: GMPRandAlg -> Int -> GMPRandAlg Source #

zeroBits :: GMPRandAlg Source #

bit :: Int -> GMPRandAlg Source #

setBit :: GMPRandAlg -> Int -> GMPRandAlg Source #

clearBit :: GMPRandAlg -> Int -> GMPRandAlg Source #

complementBit :: GMPRandAlg -> Int -> GMPRandAlg Source #

testBit :: GMPRandAlg -> Int -> Bool Source #

bitSizeMaybe :: GMPRandAlg -> Maybe Int Source #

bitSize :: GMPRandAlg -> Int Source #

isSigned :: GMPRandAlg -> Bool Source #

shiftL :: GMPRandAlg -> Int -> GMPRandAlg Source #

unsafeShiftL :: GMPRandAlg -> Int -> GMPRandAlg Source #

shiftR :: GMPRandAlg -> Int -> GMPRandAlg Source #

unsafeShiftR :: GMPRandAlg -> Int -> GMPRandAlg Source #

rotateL :: GMPRandAlg -> Int -> GMPRandAlg Source #

rotateR :: GMPRandAlg -> Int -> GMPRandAlg Source #

popCount :: GMPRandAlg -> Int Source #

FiniteBits GMPRandAlg Source # |
Instance details Defined in Numeric.GMP.Types Methods finiteBitSize :: GMPRandAlg -> Int Source # countLeadingZeros :: GMPRandAlg -> Int Source # countTrailingZeros :: GMPRandAlg -> Int Source #
Bounded GMPRandAlg Source # |
Instance details Defined in Numeric.GMP.Types Methods minBound :: GMPRandAlg Source # maxBound :: GMPRandAlg Source #
Enum GMPRandAlg Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

succ :: GMPRandAlg -> GMPRandAlg Source #

pred :: GMPRandAlg -> GMPRandAlg Source #

toEnum :: Int -> GMPRandAlg Source #

fromEnum :: GMPRandAlg -> Int Source #

enumFrom :: GMPRandAlg -> [GMPRandAlg] Source #

enumFromThen :: GMPRandAlg -> GMPRandAlg -> [GMPRandAlg] Source #

enumFromTo :: GMPRandAlg -> GMPRandAlg -> [GMPRandAlg] Source #

enumFromThenTo :: GMPRandAlg -> GMPRandAlg -> GMPRandAlg -> [GMPRandAlg] Source #

Ix GMPRandAlg Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

range :: (GMPRandAlg, GMPRandAlg) -> [GMPRandAlg] Source #

index :: (GMPRandAlg, GMPRandAlg) -> GMPRandAlg -> Int Source #

unsafeIndex :: (GMPRandAlg, GMPRandAlg) -> GMPRandAlg -> Int Source #

inRange :: (GMPRandAlg, GMPRandAlg) -> GMPRandAlg -> Bool Source #

rangeSize :: (GMPRandAlg, GMPRandAlg) -> Int Source #

unsafeRangeSize :: (GMPRandAlg, GMPRandAlg) -> Int Source #

Num GMPRandAlg Source # |
Instance details Defined in Numeric.GMP.Types Methods (+) :: GMPRandAlg -> GMPRandAlg -> GMPRandAlg Source # (-) :: GMPRandAlg -> GMPRandAlg -> GMPRandAlg Source # (*) :: GMPRandAlg -> GMPRandAlg -> GMPRandAlg Source # negate :: GMPRandAlg -> GMPRandAlg Source # abs :: GMPRandAlg -> GMPRandAlg Source # signum :: GMPRandAlg -> GMPRandAlg Source # fromInteger :: Integer -> GMPRandAlg Source #
Read GMPRandAlg Source # |
Instance details Defined in Numeric.GMP.Types Methods readsPrec :: Int -> ReadS GMPRandAlg Source # readList :: ReadS [GMPRandAlg] Source # readPrec :: ReadPrec GMPRandAlg Source # readListPrec :: ReadPrec [GMPRandAlg] Source #
Integral GMPRandAlg Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

quot :: GMPRandAlg -> GMPRandAlg -> GMPRandAlg Source #

rem :: GMPRandAlg -> GMPRandAlg -> GMPRandAlg Source #

div :: GMPRandAlg -> GMPRandAlg -> GMPRandAlg Source #

mod :: GMPRandAlg -> GMPRandAlg -> GMPRandAlg Source #

quotRem :: GMPRandAlg -> GMPRandAlg -> (GMPRandAlg, GMPRandAlg) Source #

divMod :: GMPRandAlg -> GMPRandAlg -> (GMPRandAlg, GMPRandAlg) Source #

toInteger :: GMPRandAlg -> Integer Source #

Real GMPRandAlg Source # |
Instance details Defined in Numeric.GMP.Types Methods toRational :: GMPRandAlg -> Rational Source #
Show GMPRandAlg Source # |
Instance details Defined in Numeric.GMP.Types Methods showsPrec :: Int -> GMPRandAlg -> ShowS Source # show :: GMPRandAlg -> String Source # showList :: [GMPRandAlg] -> ShowS Source #
Eq GMPRandAlg Source # |
Instance details Defined in Numeric.GMP.Types Methods (==) :: GMPRandAlg -> GMPRandAlg -> Bool Source # (/=) :: GMPRandAlg -> GMPRandAlg -> Bool Source #
Ord GMPRandAlg Source # |

Instance details

Defined in Numeric.GMP.Types

Methods

compare :: GMPRandAlg -> GMPRandAlg -> Ordering Source #

(<) :: GMPRandAlg -> GMPRandAlg -> Bool Source #

(<=) :: GMPRandAlg -> GMPRandAlg -> Bool Source #

(>) :: GMPRandAlg -> GMPRandAlg -> Bool Source #

(>=) :: GMPRandAlg -> GMPRandAlg -> Bool Source #

max :: GMPRandAlg -> GMPRandAlg -> GMPRandAlg Source #

min :: GMPRandAlg -> GMPRandAlg -> GMPRandAlg Source #